import react from 'react';
import { useSelector } from 'react-redux';

import { ViewportState } from './viewport';

import '../theme/layer.css';

const Layer: react.FC<{
  children?: JSX.Element;
}> = (props: { children?: JSX.Element }) => {
  const viewportState = useSelector(
    (state: { slippy: ViewportState }) => state.slippy
  );
  console.log(
    `--- Rendering layer, viewportState: ${JSON.stringify(viewportState)} ---`
  );

  return (
    <div
      className='background'
      style={{
        transform: `translate(${viewportState.translation.x}px, ${viewportState.translation.y}px) scale(${viewportState.scale})`,
      }}
    >
      {props.children}
    </div>
  );
};

export default Layer;
